﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Imaging;
using System.Runtime.InteropServices;

using Microsoft.Research.Kinect.Nui;
using Microsoft.Research.Kinect.Audio;
namespace personmask
{
    public partial class Form1 : Form
    {
        Runtime nui=Runtime.Kinects[0];
        byte[] playermask = new byte[640 * 480 * 4];
        PlanarImage depthimage;
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            nui = Runtime.Kinects[0];
            nui.Initialize(RuntimeOptions.UseDepthAndPlayerIndex | RuntimeOptions.UseSkeletalTracking | RuntimeOptions.UseColor);

            nui.VideoStream.Open(ImageStreamType.Video, 2, ImageResolution.Resolution640x480, ImageType.Color);
            nui.DepthStream.Open(ImageStreamType.Depth, 2, ImageResolution.Resolution320x240, ImageType.DepthAndPlayerIndex);

            nui.DepthFrameReady += new EventHandler<ImageFrameReadyEventArgs>(nui_DepthFrameReady);
            nui.VideoFrameReady += new EventHandler<ImageFrameReadyEventArgs>(nui_ColorFrameReady);
        }

        void nui_DepthFrameReady(object sender, ImageFrameReadyEventArgs e)
        {
            depthimage = e.ImageFrame.Image;
        }
        int indexOfPixelinBytes(int x, int y, int stride, int bpp)
        {
            return (x + y * stride) * bpp;
        }

        void nui_ColorFrameReady(object sender, ImageFrameReadyEventArgs e)
        {
            if (depthimage.Bits == null) return;
            ImageFrame VFrame = e.ImageFrame;
            PlanarImage VImage = VFrame.Image;
            byte player;
            short d;
            int vx, vy;

            for (int y = 0; y < depthimage.Height; y++)
            {
                for (int x = 0; x < depthimage.Width; x++)
                {
                    player = (byte)(depthimage.Bits[indexOfPixelinBytes(x, y, depthimage.Width, depthimage.BytesPerPixel)] & 0x07);
                    if (player != 0) player = 0xFF;
                    d = (short)(depthimage.Bits[indexOfPixelinBytes(x, y, depthimage.Width, depthimage.BytesPerPixel) + 1] << 8 | (depthimage.Bits[indexOfPixelinBytes(x, y, depthimage.Width, depthimage.BytesPerPixel)] & 0xF8));

                    nui.NuiCamera.GetColorPixelCoordinatesFromDepthPixel(VFrame.Resolution, VFrame.ViewArea, x, y, d, out vx, out vy);
                    vx = Math.Max(0, Math.Min(vx, VImage.Width - 2));
                    vy = Math.Max(0, Math.Min(vy, VImage.Height - 2));

                    for (int k = 0; k < 8; k++)
                    {
                        //Uncomment the two lines below and comment out the next two
                        // to see raw co-ordinate mapping in action
                        // VImage.Bits[indexOfPixelinBytes(x * 2, y * 2, VImage.Width, VImage.BytesPerPixel) + k] &= player;
                        // VImage.Bits[indexOfPixelinBytes(x * 2, y * 2 + 1, VImage.Width, VImage.BytesPerPixel) + k] &= player;
                        VImage.Bits[indexOfPixelinBytes(vx, vy, VImage.Width, VImage.BytesPerPixel) + k] &= player;
                        VImage.Bits[indexOfPixelinBytes(vx, vy + 1, VImage.Width, VImage.BytesPerPixel) + k] &= player;
                    }
                }
            }
            pictureBox1.Image = PImageToBitmap(VImage);
        }

        Bitmap PImageToBitmap(PlanarImage PImage)
        {
            Bitmap bmap = new Bitmap(
              PImage.Width,
              PImage.Height,
              PixelFormat.Format32bppRgb);
            BitmapData bmapdata = bmap.LockBits(
              new Rectangle(0, 0, PImage.Width,
                                   PImage.Height),
              ImageLockMode.WriteOnly,
              bmap.PixelFormat);
            IntPtr ptr = bmapdata.Scan0;
            Marshal.Copy(PImage.Bits,
                         0,
                         ptr,
                         PImage.Width *
                            PImage.BytesPerPixel *
                                 PImage.Height);
            bmap.UnlockBits(bmapdata);
            return bmap;
        }

        private void Form1_FormClosing(
             object sender,
             FormClosingEventArgs e)
        {
            nui.Uninitialize();
        }


    }

}
